// CPUMappingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Avionics.h"
#include "CPUMappingDlg.h"
#include "AIFRead.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCPUMappingDlg dialog


CCPUMappingDlg::CCPUMappingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCPUMappingDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCPUMappingDlg)
	m_nNumCPUs = 0;
	m_fMaxUtil = 0.0;
	//}}AFX_DATA_INIT
}


void CCPUMappingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCPUMappingDlg)
	DDX_Text(pDX, IDC_EDIT_NUM_CPU, m_nNumCPUs);
	DDX_Text(pDX, IDC_EDIT_MAX_UTIL, m_fMaxUtil);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCPUMappingDlg, CDialog)
	//{{AFX_MSG_MAP(CCPUMappingDlg)
	ON_BN_CLICKED(IDC_BUTTON_DO_MAPPING, OnButtonDoMapping)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCPUMappingDlg message handlers

void CCPUMappingDlg::OnButtonDoMapping() 
{
	UpdateData(true);
	//gTheSystem.theCEDG.putDottyMerged("c:\\temp\\cedgbefore.dot");
	//system("dotty c:\\temp\\cedgbefore.dot");
	//return;
	
	wdigraph cedg(gTheSystem.theCEDG);
	cedg.putDottyMerged("c:\\temp\\cedgbefore1.dot");
	
//	CString fn("c:\\temp\\cedg.dot");
//	cedg.putDottyMerged(fn);
	//system("dotty c:\\temp\\cedg.dot");
	//return;
#if 1
	if(m_nNumCPUs < 1) {
		AfxMessageBox("Must have total number of CPUs > 1!");
		return;
	}
	cedg.mincut(m_nNumCPUs, m_fMaxUtil, 1000);
	CString fileName("c:\\temp\\cedgmerged.dot");
	gTheSystem.theCEDG.putDottyMerged("c:\\temp\\cedgShouldntchange.dot");
	cedg.putDottyMerged(fileName);
	system("dotty c:\\temp\\cedgmerged.dot");
#endif
}

BOOL CCPUMappingDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_nNumCPUs = 2;
	m_fMaxUtil = 1.0;
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
